#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#define N_BUF		10
#define BUF_SIZE	4

struct DataBuffer
{
	size_t	ReadCount;
	char	Buffer[BUF_SIZE];
};

static struct sembuf op_raise[1] = {
			{0, 1, 0} };

static struct sembuf op_wait[1] = {
			{0, -1, 0} };

int ev_create()
{
	int ev;
 
	ev = semget(IPC_PRIVATE, 1, IPC_CREAT | 0666);

	return ev;
}

int ev_wait(int ev)
{
	return (semop(ev, op_wait, 1) >= 0);
}

int ev_raise(int ev)
{
	return (semop(ev, op_raise, 1) >=  0);
}

int ev_delete(int ev)
{
	return (semctl(ev, 0, IPC_RMID, 0) >= 0);
}

main(int argc, char* argv[])
{
	int ev_readdone = ev_create();
	int ev_writedone = ev_create();
	int shm_id;
	int fd;
	int i;
	struct DataBuffer *b;
	
	if(argc != 3)
	{
		printf("Usage: cpm SrcFile DstFile\n");
		return;
	}

	memset(&b, 0, sizeof(b));
	
	shm_id = shmget(IPC_PRIVATE, sizeof(struct DataBuffer) * N_BUF, IPC_CREAT | 0666);

	if(fork() == 0)
	{
		fd = creat(argv[2], 0664);
		b = shmat(shm_id, NULL, SHM_RDONLY);
		for(;;)
		{
			for(i = 0; i < N_BUF; ++i)
			{
				ev_wait(ev_readdone);
				if(b[i].ReadCount <= 0)
				{
					ev_raise(ev_writedone);
					shmdt(b);
					close(fd);
					exit(0);
				}
				write(fd, b[i].Buffer, b[i].ReadCount);
				ev_raise(ev_writedone);
			}
		}
		return;
	}

	for(i = 0; i < N_BUF; ++i)
		ev_raise(ev_writedone);
	
	b = shmat(shm_id, NULL, 0);

	fd = open(argv[1], O_RDONLY);

	for(;;)
	{
		for(i = 0; i < N_BUF; ++i)
		{
			ev_wait(ev_writedone);
			b[i].ReadCount = read(fd, b[i].Buffer, BUF_SIZE);
			ev_raise(ev_readdone);
			if(b[i].ReadCount <= 0)
			{
				close(fd);
				shmdt(b);
				shmctl(shm_id, IPC_RMID, NULL);
				wait(NULL);
				ev_delete(ev_readdone);
				ev_delete(ev_writedone);
				exit(0);
			}
		}
	}
}

