#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define FNAME	"/tmp"

static struct sembuf op_enter[2] = {
			{0, 0, SEM_UNDO},
			{0, 1, SEM_UNDO} };
			
static struct sembuf op_leave[1] = {
			{0, -1, IPC_NOWAIT | SEM_UNDO} };

int cs_open(char project)
{
	int cs;
	key_t k = ftok(FNAME, project);

	if(k == -1)
		return 0;
 
	cs = semget(k, 1, 0);

	return cs;
}

int cs_create(char project)
{
	int cs;
	key_t k = ftok(FNAME, project);

	if(k == -1)
		return 0;
 
	cs = semget(k, 1, IPC_CREAT | 0666);

	return cs;
}

int cs_enter(int cs)
{
	return (semop(cs, op_enter, 2) >= 0);
}

int cs_leave(int cs)
{
	return (semop(cs, op_leave, 1) >=  0);
}

int cs_delete(int cs)
{
	return (semctl(cs, 0, IPC_RMID, 0) >= 0);
}
