#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>


static struct sembuf op_raise[1] = {
			{0, 1, 0} };

static struct sembuf op_wait[1] = {
			{0, -1, 0} };

int ev_create()
{
	int ev;
 
	ev = semget(IPC_PRIVATE, 1, IPC_CREAT | 0666);

	return ev;
}

int ev_wait(int ev)
{
	return (semop(ev, op_wait, 1) >= 0);
}

int ev_raise(int ev)
{
	return (semop(ev, op_raise, 1) >=  0);
}

int ev_delete(int ev)
{
	return (semctl(ev, 0, IPC_RMID, 0) >= 0);
}

main(int argc, char* argv[])
{
	int ev_exec = ev_create();
	
	if(fork() == 0)
	{
		/* processo figlio */
		/* attende che il processo genitore
		   indichi che e' ora di eseguire il
		   comando date. Quindi crea un nuovo processo
		   per eseguire il comando.
		*/
		for(;;)
		{
			ev_wait(ev_exec);
			if(fork() == 0)
			{
				execlp("date", "date", NULL);
				return;
			}
			wait(NULL); /* attende che il comando sia terminato */
		}
		return;
	}

	for(;;)
	{
	/* ogni 5 secondi chiede al processo figlio di eseguire il comando */
		ev_raise(ev_exec);
		sleep(5);
	}
}

