#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#define BUF_SIZE	4

struct DataBuffer
{
	size_t	ReadCount;
	char	Buffer[BUF_SIZE];
};

static struct sembuf op_raise[1] = {
			{0, 1, 0} };

static struct sembuf op_wait[1] = {
			{0, -1, 0} };

int ev_create()
{
	int ev;
 
	ev = semget(IPC_PRIVATE, 1, IPC_CREAT | 0666);

	return ev;
}

int ev_wait(int ev)
{
	return (semop(ev, op_wait, 1) >= 0);
}

int ev_raise(int ev)
{
	return (semop(ev, op_raise, 1) >=  0);
}

int ev_delete(int ev)
{
	return (semctl(ev, 0, IPC_RMID, 0) >= 0);
}

main(int argc, char* argv[])
{
	int ev_readdone = ev_create();
	int ev_writedone = ev_create();
	int shm_id;
	int fd;
	struct DataBuffer *b;
	
	if(argc != 2)
	{
		printf("Usage: es2 FileName\n");
		return;
	}

	shm_id = shmget(IPC_PRIVATE, sizeof(struct DataBuffer), IPC_CREAT | 0666);

	if(fork() == 0)
	{
		b = shmat(shm_id, NULL, SHM_RDONLY);
		for(;;)
		{
			ev_wait(ev_readdone);
			if(b->ReadCount == 0)
				break;
			write(1, b->Buffer, b->ReadCount);
			ev_raise(ev_writedone);
		}
		shmdt(b);
		return;
	}

	ev_raise(ev_writedone);
	b = shmat(shm_id, NULL, 0);

	fd = open(argv[1], O_RDONLY);
	for(;;)
	{
		ev_wait(ev_writedone);
		b->ReadCount = read(fd, b->Buffer, BUF_SIZE);
		ev_raise(ev_readdone);
		if(b->ReadCount == 0)
			break;
	}
	close(fd);
	shmdt(b);
	wait(NULL);
	shmctl(shm_id, IPC_RMID, NULL);
	ev_delete(ev_readdone);
	ev_delete(ev_writedone);
}

