#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include "ev.h"

#define FNAME	"/tmp"

static struct sembuf op_raise[1] = {
			{0, 1, 0} };

static struct sembuf op_wait[1] = {
			{0, -1, 0} };

int ev_open(char project)
{
	int ev;
	key_t k = ftok(FNAME, project);

	if(k == -1)
		return 0;
 
	ev = semget(k, 1, 0);

	return ev;
}

int ev_create(char project)
{
	int ev;
	key_t k = ftok(FNAME, project);

	if(k == -1)
		return 0;
 
	ev = semget(k, 1, IPC_CREAT | 0666);

	return ev;
}

int ev_wait(int ev)
{
	return (semop(ev, op_wait, 1) >= 0);
}

int ev_raise(int ev)
{
	return (semop(ev, op_raise, 1) >=  0);
}

int ev_delete(int ev)
{
	return (semctl(ev, 0, IPC_RMID, 0) >= 0);
}
