#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>


main()
{
	char *chunk = NULL;
	int fd = -1;
	size_t page_size = getpagesize();
	size_t file_size = 0;
	size_t num_pages = 0;
	size_t current_page = 0;
	size_t buffer_size = 0;
	size_t i = 0;
	
	fd = open("./mm.b", O_RDWR);
	if(fd < 0)
	{
		perror("open failed");
		return;
	}
	
	file_size = lseek(fd, 0, SEEK_END);
	lseek(fd, 0, SEEK_SET);
	
	num_pages = file_size / page_size;
	if(file_size % page_size)
		++num_pages;
	
	for(current_page = 0; current_page < num_pages; current_page++)
	{
		buffer_size = (current_page == (num_pages - 1)) ? file_size % page_size : page_size;
		
		chunk = mmap(0, buffer_size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, page_size * current_page);
		if(chunk == MAP_FAILED)
		{
			perror("map failed");
			close(fd);
			return;
		}
	
		for(i = 0; i < buffer_size; ++i)
			if(chunk[i] >= 'a' && chunk[i] <= 'z')
				chunk[i] += 'A' - 'a';
			
		msync(chunk, buffer_size, MS_SYNC);

		munmap(chunk, buffer_size);
	}

	close(fd);
}
