#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdio.h>

#define FNAME	"/tmp"
#define BUF_SIZE	1024

#define SVR_PRJ	'\0'
#define CLT_PRJ	'\1'

#define CMD_QUIT	0
#define CMD_TOLOWER	1
#define CMD_TOUPPER	2

struct cmd {
	long command;
	char buffer[BUF_SIZE];
};

struct msg {
	long mtype;
	struct cmd data;
};

int createqueue(char project);
void strconvert(char* buffer, char low, char upr, char chr);

main()
{
	int svr_id, clt_id;
	struct msg message;
	int fExit = 0;
	int result;
	
	svr_id = createqueue(SVR_PRJ);	
	clt_id = createqueue(CLT_PRJ);
	
	while(!fExit)
	{
		msgrcv(svr_id, (struct msgbuf*)&message, sizeof(struct cmd), 0, 0);
		
		switch(message.data.command)
		{
		case CMD_QUIT:
			fExit = 1;
			break;
		case CMD_TOLOWER:
			strconvert(message.data.buffer, 'A', 'Z', 'a'-'A');
			msgsnd(clt_id, (struct msgbuf*)&message, sizeof(struct cmd), 0);
			break;
		case CMD_TOUPPER:
			strconvert(message.data.buffer, 'a', 'z', 'A'-'a');
			msgsnd(clt_id, (struct msgbuf*)&message, sizeof(struct cmd), 0);
			break;
		default:
			break;
		}
	}
	
	msgctl(svr_id, IPC_RMID, NULL);
	msgctl(clt_id, IPC_RMID, NULL);
}

int createqueue(char project)
{
	key_t k = ftok(FNAME, project);
	return msgget(k, IPC_CREAT | 0666);
}

void strconvert(char* buffer, char low, char upr, char chr)
{
	while(*buffer)
	{
		if(*buffer >= low && *buffer <= upr)
			*buffer += chr;

		++buffer;
	}
}
