#include <stdio.h>

#include <sys/types.h>

#include <unistd.h>



int main(int argc, char* argv[])

{

	pid_t pid;

	int status;

	int fd[2];

	int n;

	char line[2048];

	FILE *f;



	if(argc != 2)

	{

		printf("Usage: %s FileName\n", argv[0]);

		return -1;

	}



	status = pipe(fd);

	if(status != 0)

	{

		printf("pipe() failed\n");

		return -1;

	}



	pid = fork();



	if(pid == -1)

	{

		printf("fork() failed!\n");

		return -1;

	}



	if(pid == 0)

	{

		/* Child Process */



		close(fd[1]);

		dup2(fd[0], STDIN_FILENO);

		close(fd[0]);



		execlp("wc", "wc", NULL);

		printf("execlp() error\n");

		return 0;

	}

	else

	{

		/* Parent process */



		close(fd[0]);



		f = (FILE*)fopen(argv[1], "r");

		if(f == NULL)

		{

			printf("Unable to open file: %s\n", argv[1]);

		}

		else

		{

			while(fgets(line, sizeof(line) - 1, f) != NULL)

			{

				n = strlen(line);

				if(write(fd[1], line, n) != n)

				{

					printf("write() error\n");

					break;

				}

			}

			fclose(f);

		}



		close(fd[1]);



		wait(&status);

	}

	

	return 0;

}

