#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>
#include <unistd.h>

int cs;

struct sembuf op_enter[2] = {
			{0, 0, SEM_UNDO},
			{0, 1, SEM_UNDO} };
			
struct sembuf op_leave[1] = {
			{0, -1, IPC_NOWAIT | SEM_UNDO} };

int cs_create()
{
	cs = semget(IPC_PRIVATE, 1, IPC_CREAT | 0666);

	return (cs >= 0);
}

int cs_enter()
{
	return (semop(cs, op_enter, 2) >= 0);
}

int cs_leave()
{
	return (semop(cs, op_leave, 1) >=  0);
}

int cs_delete()
{
	return (semctl(cs, 0, IPC_RMID, 0) >= 0);
}

main()
{
	int i,j;
	if(!cs_create())
	{
		printf("cannot create critical section\n");
		return;
	}

	if(fork() == 0)
	{
		for(i = 0; i < 10; ++i)
		{
			cs_enter();
			for(j = 0; j < 10; ++j)
			{
				printf("CLIENT\n");
				usleep(10);
			}
			cs_leave();
			usleep(10);
		}
		return;
	}

	for(i = 0; i < 10; ++i)
	{
		cs_enter();
		for(j = 0; j < 10; ++j)
		{
			printf("SERVER\n");
			usleep(10);
		}
		cs_leave();
		usleep(10);
	}
	cs_delete();
	wait(NULL);
}
