#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include "ev.h"

#define PROJECT	2

#define EV_SERVER	3
#define EV_CLIENT	4

#define FILE_NAME	"/tmp"
#define BUF_SIZE	1024

#define CMD_QUIT	0
#define CMD_TOUPPER	1
#define CMD_TOLOWER	2

#define RES_OK		0
#define RES_FAIL	1

struct msg {
	int cmd;
	int result;
	int len;
	char buffer[BUF_SIZE];
};

main()
{
	key_t k = ftok(FILE_NAME, PROJECT);
	int shmid = shmget(k, sizeof(struct msg), IPC_CREAT | 0666);
	struct msg* m = shmat(shmid, NULL, 0);
	int evs = ev_create(EV_SERVER);
	int evc = ev_create(EV_CLIENT);
	int i = 0;
	
	for(;;)
	{
		ev_wait(evs);
		switch(m->cmd)
		{
			case CMD_QUIT:
				printf("CDM_QUIT\n");
				shmdt(m);
				shmctl(shmid, IPC_RMID, NULL);
				ev_delete(evs);
				ev_delete(evc);
				return;				
			case CMD_TOUPPER:
				printf("CMD_TOUPPER\n");
				for(i = 0; i < m->len; ++i)
					if(m->buffer[i] >= 'a' && m->buffer[i] <= 'z')
						m->buffer[i] += 'A' - 'a';
				m->result = RES_OK;
				break;
			case CMD_TOLOWER:
				printf("CMD_TOLOWER\n");
				for(i = 0; i < m->len; ++i)
					if(m->buffer[i] >= 'A' && m->buffer[i] <= 'Z')
						m->buffer[i] += 'a' - 'A';
				m->result = RES_OK;
				break;
			default:
					m->result = RES_FAIL;
					m->len = strlen("unknown command");
					strcpy(m->buffer, "unknown command");
					break;
		}
		ev_raise(evc);
	}
}
