#include <stdio.h>

#define NUM_DIGITS	10

struct char_stat
{
	long ndigit[NUM_DIGITS];
	long nspaces;
	long nothers;
};

void init_stats(struct char_stat *);
void print_stats(struct char_stat *);

main()
{
	int ch;
	struct char_stat stats;
	
	init_stats(&stats);
	
	while( (ch = getchar()) != EOF )
		if(ch >= '0' && ch <= '9')
			++stats.ndigit[ch - '0'];
		else if(ch == ' ' || ch == '\n' || ch =='\t')
			stats.nspaces += 1;
		else
			++stats.nothers;
	
	print_stats(&stats);
}

void init_stats(struct char_stat *stats)
{
	int i;
	
	for(i = 0; i < sizeof(stats->ndigit) / sizeof(*stats->ndigit); ++i)
		stats->ndigit[i] = 0;
	
	stats->nspaces = 0;
	stats->nothers = 0;
}

void print_stats(struct char_stat *stats)
{
	int i;
	
	printf("Digits = ");
	for(i = 0; i < NUM_DIGITS; ++i)
		printf(" %d", *(stats->ndigit + i));
	
	printf(", white spaces = %d, other = %d\n", stats[0].nspaces, (*stats).nothers);
}
